Software documentation

Development tools

Code Structure

Techniques and Standards

How To

Functional Info

Background Info

JMRI: 2007 User Poll

In late May and early June 2007, we ran three polls in the jmriusers group to learn more about what our users are actually using. This page reports the results.

There's likely to be a selection bias in the responses. People who are actively involved with JMRI are more likely to subscribe to the jmriusers group, which was necessary to learn of the poll. They are possibly more likely to reply to the poll, and more likely to have a more recent version. We should take this into account when using the results.

In the sections below, we summarize and interpret the results. The complete raw data is available at the end of the page.

JMRI Version

The poll asked which version of JMRI people were using. The results, in decreasing order of popularity, were:
  1. 74% 1.7.6 (The most recent test release at that time)
  2. 7% 1.7.5
  3. 5% 1.6.1 (The most recent production release)
  4. 5% I build my own version from the code
  5. 4% 1.7.4 and 1.7.3 combined
  6. 0% Test releases in the 1.7 series before 1.7.3
One respondent (of 266) reported using "1.5 (any)", and one reported "1.4 (any)". These may be confusions with the Java version.

Note that 1.7.6 was the most recent test release, but it was quite old. The most recent production release, 1.6.1, was very old. This may have caused more people to use the most recent test release(s) than we would have normally found. The poll's selection bias may also have resulting in more people listing the most recent test release(s) than is true of the user population as a whole, thus understating the number of people who just download the more recent production version and run.

Java Version

The poll asked which Java version JMRI was using. The results, in decreasing order of popularity, were:
  1. 35% 1.5
  2. 33% 1.6
  3. 20% 1.4
  4. 10% 1.7
  5. 0% 1.3 or earlier
Out of 159 responses, there were zero users of Java 1.3 or earlier. This is somewhat inconsistent with smallbut non-zero number of people who said they are using JMRI on original Macintosh computers, which use Java 1.1, but the response to this poll was small than to the operating system poll.

It's possible that 10% of JMRI users have downloaded test distributions of Java 1.7 from Sun, but since Java 1.7 is not generally released yet it seems more likely that some of those responses are confusions with the JMRI release number. This in turn implies that the Java 1.6 number might be a little inflated by the same mechanism.

Operating System Version

The poll asked which operating system and version was being using to run JMRI. The results, in decreasing order of popularity, were:
  1. 52% Windows XP (including SP1, SP2, Home and Professional)
  2. 13% Windows 98
  3. 11% Windows 2000
  4. 9% Mac OS X - 10.4 or later
  5. 8% Linux - combined types, with no clear leader among them
  6. 3% Windows Vista
  7. 2% Windows Millenium Edition
There were no respondents using Windows x64, Windows NT, or Windows 95. One respondent used "Windows Server (Any, including 2003)", and one "Windows (Other, including CE)".

There were four respondents (1.5%) who used Macintosh OS 8.6, 9.0 or 9.1. All of the Mac OS X respondents were using version 10.3 (4 votes) or later (20 votes).

Among only Linux varients, the responses were:

Among other operating systems, there were no respondents indicating they used OS/2, or either "Other Unix-based" or "Other non-Unix-based". One respondent was using Solaris.

Raw Data

The poll results are available from the poll page of the jmriusers Yahoo group.

Operating System Poll

The poll prompt was:

Which operating system do you run JMRI on? We'd like to know this to improve our testing and development. You can pick as many choices as you want, but please only select ones that you are using now, or are actually running on a computer that you're likely to put JMRI on soon.

A total of 266 users answered the poll.

Answer Number Fraction
Windows 95 0 votes 0.00%
Windows 98 35 votes 13.16%
Windows NT 0 votes 0.00%
Windows 2000 29 votes 10.90%
Windows Millennium Edition 6 votes 2.26%
Windows Server (any, including 2003) 1 votes 0.38%
Windows x64 (any 64-bit, including XP and Vista) 0 votes 0.00%
Windows XP (including SP1, SP2, Home and Professional) 138 votes 51.88%
Windows Vista (any except x64) 7 votes 2.63%
Windows (Other, including CE) 1 votes 0.38%
Mac OS X - 10.1, 10.2 0 votes 0.00%
Mac OS X - 10.3 4 votes 1.50%
Mac OS X - 10.4 or later 20 votes 7.52%
Macintosh - 8.6, 9.0 or 9.1 4 votes 1.50%
Linux - Ubuntu 4 votes 1.50%
Linux - Red Hat (including Centos) 5 votes 1.88%
Linux - Yellow Dog 0 votes 0.00%
Linux - Debian 4 votes 1.50%
Linux - Gentoo 1 votes 0.38%
Linux - SUSE 4 votes 1.50%
Linux - Other 2 votes 0.75%
IBM OS/2 0 votes 0.00%
Solaris - Intel or SPARC 1 votes 0.38%
Other Unix-based 0 votes 0.00%
Other non-Unix-based 0 votes 0.00%

Java Version Poll

The poll prompt was:

Which version of Java do you use when running JMRI? If you're not sure, you can find out by starting DecoderPro and looking at the 2nd line on the startup window. It'll say something like "Java version 1.5.0_07 (en_US)"; we just want the first digits, e.g. 1.5. We want this information so we can understand what language features we can and can't use in JMRI. Please only enter what you're using now, not what you plan to use or have used in the past.

A total of 159 users answered the poll.

Answer Number Fraction
1.1 0 votes 0.00%
1.2 0 votes 0.00%
1.3 0 votes 0.00%
1.4 32 votes 20.13%
1.5 56 votes 35.22%
1.6 54 votes 33.96%
1.7 17 votes 10.69%

JMRI Version Poll

The poll prompt was:

Which version of JMRI are you _currently_ running? If you're not sure, start DecoderPro or PanelPro and look at the startup window. It will say "DecoderPro 1.something.something, part of the JMRI Project"; that's the number we're looking for. We want this information to help us understand how far back we should make e.g. decoder files compatible. Please don't enter versions you no longer use, or just plan to use in the future; we want to know what you're using now.

A total of 168 users answered the poll.

Answer Number Fraction
I build my own copy
from the code
9 votes 5.36%
1.7.6 125 votes 74.40%
1.7.5 13 votes 7.74%
1.7.4 2 votes 1.19%
1.7.3 6 votes 3.57%
1.7.2 0 votes 0.00%
1.7.1 0 votes 0.00%
1.7.0 0 votes 0.00%
1.6.1 10 votes 5.95%
1.6.0 1 votes 0.60%
1.5 (any) 1 votes 0.60%
1.4 (any) 1 votes 0.60%
1.3 (any) 0 votes 0.00%
1.2 (any) 0 votes 0.00%
Before 1.2 0 votes 0.00%